#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SlackInstanceType {
    #[serde(rename = "COMMERCIAL")]
    Commercial,
    #[serde(rename = "GOV")]
    Gov,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SlackInstanceType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SlackInstanceType::Commercial => "COMMERCIAL",
            SlackInstanceType::Gov => "GOV",
            SlackInstanceType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SlackInstanceType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SlackInstanceType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SlackInstanceType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<SlackInstanceType, conjure_object::plain::ParseEnumError> {
        match v {
            "COMMERCIAL" => Ok(SlackInstanceType::Commercial),
            "GOV" => Ok(SlackInstanceType::Gov),
            v => v.parse().map(|v| SlackInstanceType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SlackInstanceType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SlackInstanceType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SlackInstanceType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
